//$Author: behle $
//$Date: 2006-06-09 13:21:28 +0200 (Fri, 09 Jun 2006) $

// azove, Another Zero One Vertex Enumeration tool
// Copyright (C) 2006, Markus Behle
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA


#ifndef CONBDDBUILDER_H
#define CONBDDBUILDER_H

#include <vector>
#include "cuddObj.hh"


class conBDDbuilder{
public: 
  conBDDbuilder(Cudd* cpMgr): mgr(cpMgr) {};

  //the constraint are represented as a^T x + c (<)= 0  
  std::vector<int> nzCoeff; // a^T
  std::vector<unsigned int> nzCoeffInd; //the coefficients are sorted in level order
  int constant;  // c
  char sense;

  ADD* buildBDD(void);
    
private:
  ADD* leqZero(const int min, const int max);
  ADD* eqZero(const int min, const int max);

  typedef std::vector<DdNode*> computedInnerTable;
  std::vector<computedInnerTable> computedTable;
  
  Cudd* mgr;
  unsigned int position;
  int cToffset;
  int localConstant;
};

#endif
